#include <stdlib.h>
#include <math.h>
#include "robocup.h"


#include "classify.h"


void parse (char *line); 



#define MAXMESG 512
#define  PI (3.1415927)


/* possible classifier outputs (integers) */
#define _UP_      "---UP---"
#define _DOWN_    "---DOWN---"
#define _CENTER_  "---CENTER---"

/* INTEGER values corresponding to the strings above */
#define _KICK_UP_     1
#define _KICK_DOWN_   2
#define _KICK_CENTER_ 3


/* classifying problem for C4.5 */
#define _KICK_TO_SCORE_ 0


/* in-house, obscure constants:

   a) _INVISIBLE_: is an "impossible angle" for
   a visible object. As all angles are normalized, 
   it follows that we can safely use the value
   -1234567.89 for objects that are not visible.

   b) _IMPOSSIBLE_SCORING_POSITION_: has the same
   value as "a)", and is used as an INVALID
   KICKING ANGLE. If this value is returned by  
   "GetKickingAngle()", it means that you can not
   score from the current position (eg, the
   OPPONENT's goal is NOT visible).
   */

#define _INVISIBLE_ -1234567.89
#define _IMPOSSIBLE_SCORING_POSITION_ _INVISIBLE_ 


/* it somehow duplicates the "robocup.h" stuff */
#define _MAX_FLAGS_ 12
#define _MAX_LINES_ 4






float GetKickingAngle();


int c45_is_visible( float fval );

float ComputeKickingAngle( float* Players, int cPlayerCnt, float* Flags, 
			   float* Lines, float Ball, float facing_dir, 
			   float goal_dist, float goal_dir );

float LowLevelComputeAngle( float goal_dist, float rel_goal_dir, 
			    float facing_dir, int raw_kick_dir);

