'\"
'\" Soar man page 
'\"
.so man.macros
.HS add-wme soar
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
add-wme \- Add a working memory element
.SH SYNOPSIS
\fBadd-wme\fR \fIid\fR \fR[\fB^\fR] \fIattribute\fR \fIvalue\fR [\fIpreference\fR]
.BE

.SH DESCRIPTION
.PP
This command adds an element to working memory.  In effect,
Soar's working memory is surgically altered by this command.
\fBadd-wme\fR adds a new wme with the given \fIid\fR, \fIattribute\fR,
\fIvalue\fR, and optional \fIpreference\fR.  The given \fIid\fR must
be an existing identifier.  The \fIattribute\fR and \fIvalue\fR fields
can be any Soar symbol.  If \fB*\fR is given in the \fIattribute\fR or
\fIvalue\fR field, Soar creates a new identifier (symbol) for that 
field.  If the \fIpreference\fR is given, it can only have the
value \fB+\fR to indicate that an acceptable preference should be
created for this wme.

.SH EXAMPLES
This example adds the attribute/value pair "message-status received"
to the identifier (symbol) \fBS1\fR:
.DS
\fBadd-wme S1 ^message-status received\fR
.DE
.PP
This example adds an attribute/value pair with an acceptable 
preference to the identifier (symbol) \fBZ2\fR.  The attribute is
"message" and the value is a unique identifier generated by Soar.
Note that since the \fB^\fR is optional, it has been left off in
this case.
.DS
\fBadd-wme Z2 message * +\fR
.DE

.SH WARNINGS
.PP
\fIThis command is inherently unstable and may have 
weird side effects (possibly even including system crashes).\fR
For example, the chunker can't backtrace through wmes created 
via \fBadd-wme\fR.  Removing input wmes or context/impasse wmes may 
have unexpected side effects.  \fIYou've been warned.\fR

.SH SEE ALSO
\fBremove-wme\fR


