'\"
'\" Soar man page 
'\"
.so man.macros
.HS alias soar
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
alias \- Define a new Soar alias
.SH SYNOPSIS
\fBalias\fR \fIname\fR [\fIprefix-string\fR]
.BE

.SH DESCRIPTION
.PP
This command defines new aliases by creating Tcl procedures
with the given \fIname\fR.  The new procedure takes an arbitrary
number of arguments and post-pends those arguments to the given
\fIprefix-string\fR before executing the command.  When invoked,
the command is executed at the global level as if typed in from
the interactive command line interpreter.  If more complex
aliases are desired, then the Tcl \fBproc\fR command can be used
to define a new procedure.  The \fBalias\fR procedure 
checks to see if the \fIname\fR already exists, and does not 
destroy existing procedures by the same name.  Existing aliases 
can be redefined, however.  Existing aliases can be removed by 
using the command \fBunalias\fR.

.SH EXAMPLES
.PP
The command \fBwmem\fR is an alias which is defined as follows:
.DS
\fBalias wmem print -depth 0 -internal\fR
.DE
.PP
If the user executes a command such as:
.DS
\fBwmem {(* ^superstate nil)}\fR
.DE
.PP
it is as if the user had typed this command:
.DS
\fBprint -depth 0 -internal {(* ^superstate nil)}\fR
.DE

.SH FILES
.TP
\fBtclsoar.tcl\fR 

The aliases for Soar provided upon startup are defined in this file.
See \fBtclsoar.tcl\fR for more examples of aliases.

.SH SEE ALSO
\fBunalias\fR

