'\"
'\" Soar man page 
'\"
.so man.macros
.HS chunk-free-problem-spaces soar
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
chunk-free-problem-spaces \- Manage chunk-free Soar problem spaces
.SH SYNOPSIS
\fBchunk-free-problem-spaces \fR[\fB-add\fR \fIspacename\fR | \fB-remove\fR \fIspacename\fR]
.BE

.SH DESCRIPTION
.PP
A chunk is a production that is learned by Soar.  Some 
problem spaces are complex enough that learning chunks
produces unsatisfactory results.  In these spaces, learning
can be disabled by declaring the problem space to be free
of chunks.
.PP
This command manages the chunk-free Soar problem spaces.
With no arguments, this command prints the current list of 
problem spaces declared chunk-free.  With arguments, it adds 
or removes a given problem space from the chunk-free problem
space list.  No chunks will be built in a problem space if that
space is declared chunk-free.

.SH OPTIONS
.TP
\fB-add\fR \fIspacename\fR
Add the \fIspacename\fR to the chunk-free problem space list.
\fIspacename\fR must be a valid Soar symbol.
.TP
\fB-remove\fR \fIspacename\fR
Remove the \fIspacename\fR from the chunk-free problem space list.
\fIspacename\fR must be present on the chunk-free problem space list.
.PP
The \fIspacename\fR must be the name of a Soar problem space.

.SH EXAMPLES
This command declares my-space to be a chunk-free problem space:
.DS
\fBchunk-free-problem-spaces -add my-space\fR
.DE
.PP
This command removes my-space from the chunk-free problem space
list enabling chunks to be built:
.DS
\fBchunk-free-problem-spaces -remove my-space\fR
.DE

.SH SEE ALSO
\fBlearn\fR, \fBchunky-problem-space\fR

