'\"
'\" Soar man page 
'\"
.so man.macros
.HS matches soar
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
matches \- List production match information
.SH SYNOPSIS
\fBmatches\fR \fIproduction-name \fR[\fB-count\fR | \fB-timetags\fR |
\fB-wmes\fR | \fB0\fR | \fB1\fR | \fB2\fR]
.br
\fBmatches \fR[\fB-assertions\fR | \fB-retractions\fR] [\fB-name\fR |
\fB-timetags\fR | \fB-wmes\fR | \fB0\fR | \fB1\fR | \fB2\fR]
.BE

.SH DESCRIPTION
.PP
This command prints partial match information for a selected
production.  It also prints the current set of productions that
are about to fire or retract in the next preference phase.  This 
information is useful for determining what changes to working memory 
are necessary in order to achieve a match of the left-hand sides
of productions.
.PP
If no production name is given, then it is assumed that the user
desires information about the match set, including both assertions
and retractions.

.SH OPTIONS
Normally both assertions and retractions are printed by the \fBmatches\fR
command.  This can be restricted using one of the following options:
.TP
\fB-assertions\fR 
List only those productions about to fire
.TP
\fB-retractions\fR
List only those productions about to retract
.PP
The optional detail specifies the kind of information desired and
must be one of the following (the \fB0\fR option is the default):
.TP
\fB-count\fR or \fB-names\fR or \fB0\fR
Print just the partial match counts.  If the match set is being
printed, then print just the production names.
.TP
\fB-timetags\fR or \fB1\fR
Print the same information as the \fB-count\fR option plus 
the timetags of wmes at the the first failing condition
.TP
\fB-wmes\fR or \fB2\fR
Print the same information as the \fB-timetags\fR option except
print the full wmes rather than just their timetags

.SH EXAMPLES
This example prints the productions which are about to fire
and the wmes that match the productions on their left-hand sides:
.DS
\fBmatches -assertions -wmes\fR
.DE
This example prints the wme timetags for a single production.  This
example takes advantage of the unique prefix abbreviation feature of 
switches.
.DS
\fBmatches -t my*first*production
.DE





