'\"
'\" Soar man page 
'\"
.so man.macros
.HS soar soar
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
soar \- Soar system
.SH SYNOPSIS
\fBsoar\fR [\fIoptions\fR]
.BE

.SH DESCRIPTION
.PP
This command creates new Soar interpreters identified by
given \fIname\fRs.  The various options specify any special
initialization conditions, if any.  The most important
option is the \fItype\fR which indicates what type of 
interpreter is to be created and must be one of the following 
values:
.TP
\fB-agent\fR
Create agent interpreter(s).  This includes Tcl + Soar.
.TP
\fB-tclsh\fR
Create tclsh interpreter(s).  Tclsh includes only Tcl.
.PP
One or more \fIname\fRs may be given after the above \fItype\fRs.
If no \fItype\fR is given on the command line when Soar is 
invoked, a single \fB-agent\fR interpreter is created with the
\fIname\fR \fBsoar\fR.  Within Soar, it is an error to call this
command without specifying some interpreter \fIname\fR to create.
.PP
Once the Soar system has started, the command
\fBcreate-interp\fR can be used to add additional interpreters.
 
.SH OPTIONS
Environment variables used below are assumed to be defined in the Unix
shell used to start Soar.
.TP
\fB-path\fR
Use the given sequence of directories to scan for agent initialization
files.  The sequence is a colon (:) separated list of directories.  The
default value is ".:$HOME", where $HOME is the user's home directory.
Agent initialization files are assumed to be named \fIname\fR.soar.
.TP
\fB-file\fR
Specifies a file to run immediately after defining the last interpreter.
This only applies when invoking Soar.
.TP
\fB-help\fR
Lists all available options for this command.
.TP
\fB-verbose\fR
Print diagnostic information about options as each interpreter is
defined.

.SH EXAMPLES
.PP
The following example starts Soar with two agents named \fBfred\fR and
\fBwilma\fR and a single tclsh interpreter named \fBbedrock\fR.  This setup 
might be used to run a simulator in the tclsh interpreter \fBbedrock\fR
that the agents \fBfred\fR and \fBwilma\fR can interact in.
.DS
\fBsoar -agent fred wilma -tclsh bedrock\fR
.DE
.PP
This example has the extra option \fB-foo bar\fR.  Since this is not
recognized as a valid command line option, it is passed on to each 
interpreter defined on the command line.  This information appears in
the Tcl variable \fBargv\fR and can be used to pass startup
information to user-defined Tcl procedures.
.DS
\fBsoar -foo bar -agent fred wilma -wish bedrock\fR
.DE
