'\"
'\" Soar man page 
'\"
.so man.macros
.HS soartk soar
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
soartk \- Soar system with Tk extension
.SH SYNOPSIS
\fBsoartk\fR [\fIoptions\fR]
.BE

.SH DESCRIPTION
.PP
This command creates new Soar interpreters identified by
given \fIname\fRs.  The various options specify any special
initialization conditions, if any.  The most important
option is the \fItype\fR which indicates what type of 
interpreter is to be created and must be one of the following 
values:
.TP
\fB-agent\fR
Create agent interpreter(s).  This includes Tcl + Tk + Soar if
Tk is enabled, otherwise this includes Tcl + Soar.
.TP
\fB-wish\fR
Create wish interpreter(s).  Wish includes Tcl + Tk.  This is 
available only if Tk is enabled.
.TP
\fB-tclsh\fR
Create tclsh interpreter(s).  Tclsh includes only Tcl.
.PP
One or more \fIname\fRs may be given after the above \fItype\fRs.
If no \fItype\fR is given on the command line when Soar is 
invoked, a single \fB-agent\fR interpreter is created with the
\fIname\fR \fBsoar\fR.  Within Soar, it is an error to call this
command without specifying some interpreter \fIname\fR to create.
.PP
Tk is enabled if Soar has been compiled with the USE_TK option,
the $DISPLAY environment variable is set, and the \fB-noTk\fR 
option has not been given on the command line
(see below).
.PP
Once the Soar Tcl/Tk system has started, the command
\fBcreate-interp\fR can be used to add additional interpreters.
 
.SH OPTIONS
Environment variables used below are assumed to be defined in the Unix
shell used to start Soar.
.TP
\fB-path\fR
Use the given sequence of directories to scan for agent initialization
files.  The sequence is a colon (:) separated list of directories.  The
default value is ".:$HOME", where $HOME is the user's home directory.
Agent initialization files are assumed to be named \fIname\fR.soar.
.TP
\fB-display\fR
Place the top-level window associated with the interpreter on the indicated
display.  The value of this option follows standard X conventions for
specifying displays.  The default is the value of $DISPLAY.  This
only applies to wish-based shells.
.TP
\fB-file\fR
Specifies a file to run immediately after defining the last interpreter.
This only applies when invoking Soar.
.TP
\fB-geometry\fR
Specifies the geometry (width, height, and placement) of the top-level
window associated with the interpreter.  The value of this option
follows standard X conventions for specifying geometries.  This only 
applies to wish-based shells.
.TP
\fB-help\fR
Lists all available options for this command.
.TP
\fB-noTk\fR
Do not use Tk when creating any subsequent interpreters.  This option
applies to the rest of the command line.
.TP
\fB-sync\fR
Use synchronous X server updates with all subsequent wish-based
interpreter windows.  This applies only to wish-based shells.
.TP
\fB-verbose\fR
Print diagnostic information about options as each interpreter is
defined.

.SH EXAMPLES
.PP
The following example starts Soar with two agents named \fBfred\fR and
\fBwilma\fR and a single wish interpreter named \fBbedrock\fR.  This setup 
might be used to run a simulator in the wish interpreter \fBbedrock\fR
that the agents \fBfred\fR and \fBwilma\fR can interact in.
.DS
\fBsoartk -agent fred wilma -wish bedrock\fR
.DE
.PP
The next example is similar to the one above, except that the simulator
display will be moved to the X display \fBsgi1:0.0\fR.  Also, the
switch \fB-v\fR has been added to indicate that we want detailed
information about defined options as each interpreter is created.
Note that all option names may be abbreviated to any prefix which
uniquely distinguishes it from the other options.
.DS
\fBsoartk -v -agent fred wilma -display sgi1:0.0 -wish bedrock\fR
.DE
.PP
This example has the extra option \fB-foo bar\fR.  Since this is not
recognized as a valid command line option, it is passed on to each 
interpreter defined on the command line.  This information appears in
the Tcl variable \fBargv\fR and can be used to pass startup
information to user-defined Tcl procedures.
.DS
\fBsoartk -foo bar -agent fred wilma -wish bedrock\fR
.DE