/********************************************************************
 * Intercept Utilities: macros and declarations
 *   GalK, 26/6/97
 ********************************************************************/

#ifndef __INTERCEPT_H
#define __INTERCEPT_H

#ifndef __INTERCEPT_EXTERN__
#define __INTERCEPT_EXTERN__ extern
#endif

#define PI (3.1415927)
#define ANG45 (0.78539816)
#define GOAL_LOC (-54)

#define INCRDDIR 4

#define DASHINC (45.0)
#define DASHINC2 (70.0)

#define DASHOFF (20.0)

#define MAXDASH 100

#define CLOSE (1.0)

#define ALMOST (1.5)

#define ALMOST_STRAIGHT (1.0)
#define ALMOST_GO (.5)

#define THUG_DX (-100)



/* XXX should also return likelihood */


__INTERCEPT_EXTERN__ void intercept(double, /* dx */
				    double /* dir */,
				    double /* ddx */,
				    double /* ddir */, 
				    double /* absx */,
				    double /* absy */,
				    double /* absdir */,
				    int    /* player */,
				    double * /* turn */, 
				    double * /* dash */);

__INTERCEPT_EXTERN__ void intercept_init(void);

__INTERCEPT_EXTERN__ double Incrddir;
__INTERCEPT_EXTERN__ double Dashinc;
__INTERCEPT_EXTERN__ double Dashinc2;
__INTERCEPT_EXTERN__ double Dashoff;
__INTERCEPT_EXTERN__ double Maxdash;
__INTERCEPT_EXTERN__ double Close;
__INTERCEPT_EXTERN__ double Almost;
__INTERCEPT_EXTERN__ double Almost_go;
__INTERCEPT_EXTERN__ double Almost_straight;
__INTERCEPT_EXTERN__ double Thug_dx;
__INTERCEPT_EXTERN__ double Goal_Loc;


#endif
