/* File   : robocup.c
   Info   : Soccer simulator competition main file
   Authors: Ali Erdem
   Date   : April 30, 1997
*/


#define __ROBOCUP_EXTERN__
#include "robocup.h"


extern Socket init_connection(char *, int);

/* modified form of ernesto_receive_and_parse */
void receive_and_parse_init()
{
    char buf[BUFSIZE1];
    int n =0;
    Bool received_init = FALSE;

    do {
      if (receive_message((Socket *)&gSock, buf, BUFSIZE1))
	{
	  /* the parser from Japan doesn't know about the init messages, so
	     we need to handle them here */
	  
#ifdef DEBUG
	  printf("robocup.c/receive_and_parse_init: Received %s\n",buf);
#endif
	  if (buf[1] == 'i')
	    {
	      char i_side,i_msg[BUFSIZE1];
	      
	      sscanf(buf,"(init %c %d %s)",&i_side,&MyNumber,i_msg);
	      if (i_side == 'l') {
		MySide = S_LEFT;
	      } else if (i_side == 'r') {
		MySide = S_RIGHT;
	      } else {
		fprintf(stderr,"robocup.c/receive_and_parse_init: Invalid init message: %s\n",buf);
		exit(1);
	      }
	      
	      received_init = TRUE;
#ifdef DEBUG
	      printf("i_side=%c  MyNumber=(%d)  i_msg=%s  MySide=%d\n",i_side,MyNumber,i_msg,MySide);
#endif
	    }
	  else
	    {
#ifdef DEBUG
	      fprintf(stderr,"robocup.c/receive_and_parse_init: received non init_msg: %s\n",buf);
#endif
	    }
	}
      else
	{
#ifdef DEBUG
	  fprintf(stderr,"robocup.c/receive_and_parse_init: waiting for init_msg from server\n");
#endif
	}
    }
    while (!received_init);

    return ;
}



Bool receive_and_parse() {

    char buf[BUFSIZE1];
    int n =0;
 
    if (receive_message((Socket *)&gSock, buf, BUFSIZE1))
      {
        /* we should not receive any more init msgs */
#ifdef DEBUG
        printf("robocup.c/receive_and_parse: Received %s\n",buf);
#endif

	parse(buf);

	return TRUE; /* received input this cycle */
      }

    return FALSE;
}



void robocup_init(void)
{
  char temp[100];
  int l, j;

#ifdef DEBUG
  printf("robocup.c/robocup_init: server %s, port %d\n", Server, Port);
#endif
 
  gSock = init_connection(Server,Port);
  if (gSock.socketfd == -1) {
     fprintf(stderr,"robocup.c/robocup_init: Socket initialization failed\n"); 
     exit(1) ;
  }
  if (sprintf(temp,"(init %s)",Teamname) > 0) {
     if (send_message(gSock,temp)) {
       receive_and_parse_init();
     } else {
        fprintf(stderr,"robocup.c/robocup_init: Failed to send initialization message\n");
        exit(1);
     }
  } else {
    fprintf(stderr,"robocup.c/robocup_init: Failed to initialize the message\n");
    exit(1);
  }

  /* bzero(State, sizeof(state)*NUM_OF_STATES); */

  return ; 
}     
   
