/*
 * $Id: scheduler.c,v 1.3 1994/08/23 10:38:26 portelli Exp $
 * $Log: scheduler.c,v $
 * Revision 1.3  1994/08/23  10:38:26  portelli
 * For 6.2.4
 *
 * Revision 1.2  1993/11/21  17:22:24  soarhack
 * 6.1.1 checkin
 *
 * Revision 1.1  1993/06/17  20:47:58  jtraub
 * Released
 *
 * Revision 0.1  1993/06/17  20:24:30  jtraub
 * 6.1_checkin
 *
 * Revision 9.2  1993/05/10  18:37:38  jtraub
 * added RCS header information
 *
 */

#include <soar.h>
#include <soarCommands.h>
#include <soarCommandUtils.h>
#include <soarScheduler.h>

long scheduler_cycle_count = 0;

Soar_ScheduledInterp Soar_BeforeSchedule = {NULL, NULL};
Soar_ScheduledInterp Soar_AfterSchedule = {NULL, NULL};

int
schedule_agents (Tcl_Interp * interp, int cycles) 
{
  bool agent_to_run = TRUE;
  cons  * c; 
  agent * the_agent; 
  agent * prev_agent;
  int cycle_count = 0;

  prev_agent = soar_agent;

  for(c = all_soar_agents; c != NIL; c = c->rest) {
    the_agent = (agent *) c->first;
    the_agent->stop_soar = FALSE;
  }

  while (TRUE) {

    if (cycle_count == cycles) break;
    cycle_count++;

    agent_to_run = FALSE;
    for(c = all_soar_agents; c != NIL; c = c->rest) {
      soar_agent = (agent *) c->first;
      if (!(soar_agent->stop_soar)) {
	agent_to_run = TRUE;
      }
    }

    if (!agent_to_run) break;

    if (Soar_BeforeSchedule.interp != NULL) {
      int code;

      code = Tcl_GlobalEval(Soar_BeforeSchedule.interp, 
			    Soar_BeforeSchedule.script);

      if (code != TCL_OK)
	{
	  interp->result = Soar_BeforeSchedule.interp->result;
	  return TCL_ERROR;
	}
    }

    for(c = all_soar_agents; c != NIL; c = c->rest) {
      soar_agent = (agent *) c->first;

      Soar_SelectGlobalInterpByInterp(soar_agent->interpreter);

     if (!current_agent(stop_soar)) {

       soar_invoke_callbacks(soar_agent, 
			     BEFORE_SCHEDULE_CYCLE_CALLBACK,
			     (soar_call_data) TRUE);

       execute_go_selection(soar_agent,
			    soar_agent->go_number,
			    soar_agent->go_type,
			    soar_agent->go_slot_attr,
			    soar_agent->go_slot_level);

       soar_invoke_callbacks(soar_agent, 
			     AFTER_SCHEDULE_CYCLE_CALLBACK,
			     (soar_call_data) TRUE);
     } /* if */
    } /* for */

    if (Soar_AfterSchedule.interp != NULL) {
      int code;

      code = Tcl_GlobalEval(Soar_AfterSchedule.interp, 
			    Soar_AfterSchedule.script);

      if (code != TCL_OK)
	{
	  interp->result = Soar_AfterSchedule.interp->result;
	  return TCL_ERROR;
	}
    }


  } /* while */

  soar_agent = prev_agent;

  Soar_SelectGlobalInterpByInterp(soar_agent->interpreter);

  return TCL_OK;
}
